//+------------------------------------------------------------------+
//|                                                Kaufmam Trend.mq4 |
//|                         Copyright  2007, ATRLAB [Andrew Opeyda] |
//|                                   www.ATRLAB.com info@atrlab.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, ATRLAB [Andrew Opeyda]"
#property link      "www.ATRLAB.com info@atrlab.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Red
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_color4 Blue
#property indicator_color5 Red
#property indicator_color6 Red
#property indicator_color7 Red
#property indicator_color8 Red
//---- input parameters
extern int       periodAMA1=46;
extern double    nfast1=3.4;
extern double    nslow1=5;
extern double    G1=2.0;
extern double    dK1=2.0;

extern int       periodAMA2=44;
extern double    nfast2=1;
extern double    nslow2=32.0;
extern double    G2=5.0;
extern double    dK2=2.0;

extern int       periodAMA3=45;
extern double    nfast3=1;
extern double    nslow3=49.0;
extern double    G3=3.0;
extern double    dK3=2.0;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];

bool long = false;
/*
343	6864.98	116	2.16	59.18	2103.70	19.11%
	periodAMA1=46 	nfast1=3.4 	nslow1=5 	G1=2
	periodAMA2=44 	nfast2=1 	nslow2=23 	G2=5
	periodAMA3=45 	nfast3=1 	nslow3=49 	G3=3
	SL=1230 	TP=1230 	dK1=2 	dK2=2 	dK3=2
*/
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexStyle(7,DRAW_LINE);
   SetIndexBuffer(7,ExtMapBuffer8);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   for (int i = 0; i<5000; i++)
   {
      double k1 = iCustom(NULL,0,"Kaufman optimized" ,periodAMA1, nfast1,nslow1, G1, dK1, 0, 1,   0,i);
      double k2 = iCustom(NULL,0,"Kaufman optimized" ,periodAMA2, nfast2,nslow2, G2, dK2, 0, 1,   0,i);
      double k3 = iCustom(NULL,0,"Kaufman optimized" ,periodAMA3, nfast3,nslow3, G3, dK3, 0, 1,   0,i);
         
      
      if ((k1 > k2) && (k2 > k3))
      {   

         long = true;
         
      }
            
      if ((k1 < k2) && (k2 < k3))
      {
         long = false;   
         
      }          
       
       
       if (long)
       {
       ExtMapBuffer3[i] = High[i];ExtMapBuffer4[i] = Low[i];      
       }
       else
       {
       ExtMapBuffer1[i] = High[i];ExtMapBuffer2[i] = Low[i];
       }
            
     ExtMapBuffer6[i] = k1;
     ExtMapBuffer7[i] = k2;
     ExtMapBuffer8[i] = k3;
      
   }
         
         
//----
   return(0);
  }
//+------------------------------------------------------------------+