#property copyright "Copyright  2006-2009, ATRLAB [Andrew Opeyda]"
#property link      "www.ATRLAB.com info@atrlab.com"

#include <WinUser32.mqh>

#import "FreeImage.dll"
   void _FreeImage_Initialise@4(int a0);
   void _FreeImage_DeInitialise@0();
   int _FreeImage_Load@12(int a0, string a1, int a2);
   int _FreeImage_ConvertTo24Bits@4(int a0);
   int _FreeImage_GetWidth@4(int a0);
   int _FreeImage_GetHeight@4(int a0);
   bool _FreeImage_GetPixelColor@16(int a0, int a1, int a2, int& a3[]);
   bool _FreeImage_SetPixelColor@16(int a0, int a1, int a2, int& a3[]);
   int _FreeImage_Copy@20(int a0, int a1, int a2, int a3, int a4);
   int _FreeImage_RotateClassic@12(int a0, double a1);
#import "wininet.dll"
   int InternetOpenA(string a0, int a1, string a2, string a3, int a4);
   int InternetOpenUrlA(int a0, string a1, string a2, int a3, int a4, int a5);
   int InternetReadFile(int a0, string a1, int a2, int& a3[]);
   int InternetCloseHandle(int a0);
#import

string gs_unused_76 = "MQL wrapper for FreeImage.dll";
extern string OandaPictureSource = "";
extern int TimeZoneCorrection = 6;
extern bool Cumulative = FALSE;
extern bool ShowTrades = FALSE;
extern bool ShowOrders = TRUE;
extern bool DrawBack = TRUE;
extern int GraphWidth_bars = 35;
extern color Color_OrdersGreen = C'0xBD,0xDE,0x7A';
extern color Color_OrdersBlue = C'0xFF,0xA9,0x88';
extern color Color_OrdersPrice = Black;
extern color Color_OrdersAxis = Black;
extern color Color_TradesGreen = LimeGreen;
extern color Color_TradesBlue = CornflowerBlue;
extern color Color_TradesPrice = Goldenrod;
extern color Color_TradesAxis = LimeGreen;
extern int LineWidth = 2;
extern int PriceWidth = 1;
int g_color_156 = YellowGreen;
int g_color_160 = SteelBlue;
int g_color_164 = DarkOrange;
int gi_unused_168 = 0;
int gi_unused_172 = 0;
int gi_176 = -1;
int gi_unused_180 = 0;
string gs_unused_184 = "";
string gsa_192[256];
int gi_196 = 1;
int gi_200 = 1;
int gi_204 = 1;
int gia_208[];
int gia_212[];
int gia_216[];
double gda_220[];
int gia_224[];
string gsa_228[];
int gia_232[];
int gia_236[];
int gia_240[];
double gda_244[];
int gia_248[];
string gsa_252[];
int gia_256[];
int gia_260[];
int gia_264[];
double gda_268[];
int gia_272[];
string gsa_276[];
string gsa_280[256];
int g_datetime_284 = 0;

int fi_GetPixel(int ai_0, int ai_4, int ai_8) {
   int lia_12[] = {-1};
   int li_16 = _FreeImage_GetHeight@4(ai_0);
   _FreeImage_GetPixelColor@16(ai_0, ai_4, li_16 - 1 - ai_8, lia_12);
   return (lia_12[0]);
}

int fi_CopyBox(int ai_0, int ai_4, int ai_8, int ai_12, int ai_16) {
   return (_FreeImage_Copy@20(ai_0, ai_4, ai_8, ai_12 + 1, ai_16 + 1));
}

int fi_CropBox(int ai_0, int &ai_4, int &ai_8, int &ai_12, int &ai_16, int ai_20) {
   int li_24;
   for (ai_4 = ai_4; ai_4 <= ai_12; ai_4++) {
      for (int li_28 = ai_8; li_28 <= ai_16; li_28++) {
         li_24 = fi_GetPixel(ai_0, ai_4, li_28);
         if (li_24 != ai_20) break;
      }
      if (li_24 != ai_20) break;
   }
   for (ai_12 = ai_12; ai_12 >= ai_4; ai_12--) {
      for (li_28 = ai_8; li_28 <= ai_16; li_28++) {
         li_24 = fi_GetPixel(ai_0, ai_12, li_28);
         if (li_24 != ai_20) break;
      }
      if (li_24 != ai_20) break;
   }
   for (ai_8 = ai_8; ai_8 <= ai_16; ai_8++) {
      for (int li_32 = ai_4; li_32 <= ai_12; li_32++) {
         li_24 = fi_GetPixel(ai_0, li_32, ai_8);
         if (li_24 != ai_20) break;
      }
      if (li_24 != ai_20) break;
   }
   for (ai_16 = ai_16; ai_16 >= ai_8; ai_16--) {
      for (li_32 = ai_4; li_32 <= ai_12; li_32++) {
         li_24 = fi_GetPixel(ai_0, li_32, ai_16);
         if (li_24 != ai_20) break;
      }
      if (li_24 != ai_20) break;
   }
   return (fi_CopyBox(ai_0, ai_4, ai_8, ai_12, ai_16));
}

int fi_CropBoxOnly(int ai_0, int ai_4, int ai_8, int ai_12, int ai_16, int ai_20) {
   int li_24 = ai_4;
   int li_28 = ai_8;
   int li_32 = ai_12;
   int li_36 = ai_16;
   return (fi_CropBox(ai_0, li_24, li_28, li_32, li_36, ai_20));
}

void GetBorderPrices(int ai_0, double &a_str2dbl_4, int &ai_12, double &a_str2dbl_16, int &ai_24, int ai_28) {
   int li_32;
   int li_36 = fi_CopyBox(ai_0, 76, 198, 434, 241);
   ai_0 = _FreeImage_RotateClassic@12(li_36, -90.0);
   int li_40 = _FreeImage_GetWidth@4(ai_0);
   int li_44 = _FreeImage_GetHeight@4(ai_0);
   for (int l_count_48 = 0; l_count_48 < li_44; l_count_48++) {
      for (int l_count_52 = 0; l_count_52 < li_40; l_count_52++) {
         li_32 = fi_GetPixel(ai_0, l_count_52, l_count_48);
         if (li_32 != ai_28) break;
      }
      if (li_32 != ai_28) break;
   }
   for (l_count_48 = l_count_48; l_count_48 < li_44; l_count_48++) {
      for (l_count_52 = 0; l_count_52 < li_40; l_count_52++) {
         li_32 = fi_GetPixel(ai_0, l_count_52, l_count_48);
         if (li_32 != ai_28) break;
      }
      if (l_count_52 >= li_40) break;
   }
   for (l_count_48 = l_count_48; l_count_48 < li_44; l_count_48++) {
      for (l_count_52 = 0; l_count_52 < li_40; l_count_52++) {
         li_32 = fi_GetPixel(ai_0, l_count_52, l_count_48);
         if (li_32 != ai_28) break;
      }
      if (li_32 != ai_28) break;
   }
   for (int li_56 = l_count_48; li_56 < li_44; li_56++) {
      for (l_count_52 = 0; l_count_52 < li_40; l_count_52++) {
         li_32 = fi_GetPixel(ai_0, l_count_52, li_56);
         if (li_32 != ai_28) break;
      }
      if (l_count_52 >= li_40) break;
   }
   ai_12 = l_count_48 + 76 + 3;
   int li_60 = fi_CopyBox(ai_0, 0, l_count_48, li_40 - 1, li_56 - 1);
   a_str2dbl_4 = StrToDouble(OcrImage(li_60, ai_28, 0));
   for (l_count_48 = li_56; l_count_48 < li_44; l_count_48++) {
      for (l_count_52 = 0; l_count_52 < li_40; l_count_52++) {
         li_32 = fi_GetPixel(ai_0, l_count_52, l_count_48);
         if (li_32 != ai_28) break;
      }
      if (li_32 != ai_28) break;
   }
   for (li_56 = l_count_48; li_56 < li_44; li_56++) {
      for (l_count_52 = 0; l_count_52 < li_40; l_count_52++) {
         li_32 = fi_GetPixel(ai_0, l_count_52, li_56);
         if (li_32 != ai_28) break;
      }
      if (l_count_52 >= li_40) break;
   }
   ai_24 = l_count_48 + 76 + 3;
   li_60 = fi_CopyBox(ai_0, 0, l_count_48, li_40 - 1, li_56 - 1);
   a_str2dbl_16 = StrToDouble(OcrImage(li_60, ai_28, 0));
}

string OcrImage(int ai_0, int ai_4, int ai_8) {
   int li_12;
   string lsa_16[15];
   string lsa_20[15];
   string lsa_24[256];
   string lsa_28[256];
   int li_32;
   int li_36;
   int li_40;
   int li_44;
   int li_48;
   string ls_ret_52 = "";
   string ls_60 = "";
   lsa_20[0] = "A";
   lsa_16[0] = "  ==  " + " =  = " + "=    =" + "=    =" + "=    =" + "======" + "=    =" + "=    =" + "=    =" + "=    =";
   lsa_20[1] = "B";
   lsa_16[1] = "===== " + "=    =" + "=    =" + "=    =" + "===== " + "=    =" + "=    =" + "=    =" + "=    =" + "===== ";
   lsa_20[2] = "C";
   lsa_16[2] = " ==== " + "=    =" + "=     " + "=     " + "=     " + "=     " + "=     " + "=     " + "=    =" + " ==== ";
   lsa_20[3] = "D";
   lsa_16[3] = "====  " + "=   = " + "=    =" + "=    =" + "=    =" + "=    =" + "=    =" + "=    =" + "=   = " + "====  ";
   lsa_20[4] = "E";
   lsa_16[4] = "======" + "=     " + "=     " + "=     " + "===== " + "=     " + "=     " + "=     " + "=     " + "======";
   lsa_20[5] = "F";
   lsa_16[5] = "======" + "=     " + "=     " + "=     " + "===== " + "=     " + "=     " + "=     " + "=     " + "=     ";
   lsa_20[6] = "G";
   lsa_16[6] = " ==== " + "=    =" + "=     " + "=     " + "=     " + "=  ===" + "=    =" + "=    =" + "=   ==" + " === =";
   lsa_20[7] = "H";
   lsa_16[7] = "=    =" + "=    =" + "=    =" + "=    =" + "======" + "=    =" + "=    =" + "=    =" + "=    =" + "=    =";
   lsa_20[8] = "J";
   lsa_16[8] = "   ===" + "    = " + "    = " + "    = " + "    = " + "    = " + "    = " + "=   = " + "=   = " + " ===  ";
   lsa_20[9] = "P";
   lsa_16[9] = "===== " + "=    =" + "=    =" + "=    =" + "===== " + "=     " + "=     " + "=     " + "=     " + "=     ";
   lsa_20[10] = "R";
   lsa_16[10] = "===== " + "=    =" + "=    =" + "=    =" + "===== " + "=  =  " + "=   = " + "=   = " + "=    =" + "=    =";
   lsa_20[11] = "S";
   lsa_16[11] = " ==== " + "=    =" + "=    =" + "=     " + " ==   " + "   == " + "     =" + "=    =" + "=    =" + " ==== ";
   lsa_20[12] = "U";
   lsa_16[12] = "=    =" + "=    =" + "=    =" + "=    =" + "=    =" + "=    =" + "=    =" + "=    =" + "=    =" + " ==== ";
   lsa_20[13] = "Y";
   lsa_16[13] = "=     =" + "=     =" + " =   = " + " =   = " + "  = =  " + "   =   " + "   =   " + "   =   " + "   =   " + "   =   ";
   lsa_20[14] = "";
   lsa_16[14] = "";
   lsa_28[32] = " ";
   lsa_24[32] = "";
   lsa_28[33] = "!";
   lsa_24[33] = "";
   lsa_28[34] = "\"";
   lsa_24[34] = "";
   lsa_28[35] = "#";
   lsa_24[35] = "";
   lsa_28[36] = "$";
   lsa_24[36] = "";
   lsa_28[37] = "%";
   lsa_24[37] = " =  =" + "= = =" + " = = " + "   = " + "  =  " + " =   " + " = = " + "= = =" + "=  = ";
   lsa_28[38] = "&";
   lsa_24[38] = "";
   lsa_28[39] = "\'";
   lsa_24[39] = "";
   lsa_28[40] = "(";
   lsa_24[40] = "  =" + " = " + "=  " + "=  " + "=  " + "=  " + " = " + "  =";
   lsa_28[41] = ")";
   lsa_24[41] = "=  " + " = " + "  =" + "  =" + "  =" + "  =" + " = " + "=  ";
   lsa_28[42] = "*";
   lsa_24[42] = "";
   lsa_28[43] = "+";
   lsa_24[43] = "  =  " + "  =  " + "=====" + "  =  " + "  =  " + "     ";
   lsa_28[44] = ",";
   lsa_24[44] = "";
   lsa_28[45] = "-";
   lsa_24[45] = "=====";
   lsa_28[46] = ".";
   lsa_24[46] = "==" + "==";
   lsa_28[47] = "/";
   lsa_24[47] = "    =" + "    =" + "   = " + "   = " + "  =  " + " =   " + " =   " + "=    " + "=    ";
   lsa_28[48] = "0";
   lsa_24[48] = "  =  " + " = = " + "=   =" + "=   =" + "=   =" + "=   =" + " = = " + "  =  ";
   lsa_28[49] = "1";
   lsa_24[49] = "  =  " + " ==  " + "= =  " + "  =  " + "  =  " + "  =  " + "  =  " + "=====";
   lsa_28[50] = "2";
   lsa_24[50] = " === " + "=   =" + "    =" + "   = " + "  =  " + " =   " + "=    " + "=====";
   lsa_28[51] = "3";
   lsa_24[51] = " === " + "=   =" + "    =" + "  == " + "    =" + "    =" + "=   =" + " === ";
   lsa_28[52] = "4";
   lsa_24[52] = "   = " + "  == " + " = = " + "=  = " + "=  = " + "=====" + "   = " + "   = ";
   lsa_28[53] = "5";
   lsa_24[53] = "=====" + "=    " + "==== " + "=   =" + "    =" + "    =" + "=   =" + " === ";
   lsa_28[54] = "6";
   lsa_24[54] = "  ===" + " =   " + "=    " + "==== " + "=   =" + "=   =" + "=   =" + " === ";
   lsa_28[55] = "7";
   lsa_24[55] = "=====" + "    =" + "   = " + "   = " + "  =  " + "  =  " + " =   " + " =   ";
   lsa_28[56] = "8";
   lsa_24[56] = " === " + "=   =" + "=   =" + " === " + "=   =" + "=   =" + "=   =" + " === ";
   lsa_28[57] = "9";
   lsa_24[57] = " === " + "=   =" + "=   =" + "=   =" + " ====" + "    =" + "   = " + "===  ";
   lsa_28[58] = ":";
   lsa_24[58] = "==" + "==" + "  " + "  " + "==" + "==";
   lsa_28[59] = ";";
   lsa_24[59] = "";
   lsa_28[60] = "<";
   lsa_24[60] = "";
   lsa_28[61] = "=";
   lsa_24[61] = "";
   lsa_28[62] = ">";
   lsa_24[62] = "";
   lsa_28[63] = "?";
   lsa_24[63] = "";
   lsa_28[64] = "@";
   lsa_24[64] = "";
   lsa_28[65] = "A";
   lsa_24[65] = "  =  " + " = = " + "=   =" + "=   =" + "=====" + "=   =" + "=   =" + "=   =";
   lsa_28[66] = "B";
   lsa_24[66] = "==== " + "=   =" + "=   =" + "==== " + "=   =" + "=   =" + "=   =" + "==== ";
   lsa_28[67] = "C";
   lsa_24[67] = " === " + "=   =" + "=    " + "=    " + "=    " + "=    " + "=   =" + " === ";
   lsa_28[68] = "D";
   lsa_24[68] = "==== " + "=   =" + "=   =" + "=   =" + "=   =" + "=   =" + "=   =" + "==== ";
   lsa_28[69] = "E";
   lsa_24[69] = "=====" + "=    " + "=    " + "==== " + "=    " + "=    " + "=    " + "=====";
   lsa_28[70] = "F";
   lsa_24[70] = "=====" + "=    " + "=    " + "==== " + "=    " + "=    " + "=    " + "=    ";
   lsa_28[71] = "G";
   lsa_24[71] = " === " + "=   =" + "=    " + "=    " + "=  ==" + "=   =" + "=   =" + " === ";
   lsa_28[72] = "H";
   lsa_24[72] = "=   =" + "=   =" + "=   =" + "=====" + "=   =" + "=   =" + "=   =" + "=   = ";
   lsa_28[73] = "I";
   lsa_24[73] = "";
   lsa_28[74] = "J";
   lsa_24[74] = "   =" + "   =" + "   =" + "   =" + "   =" + "   =" + "=  =" + " == ";
   lsa_28[75] = "K";
   lsa_24[75] = "";
   lsa_28[76] = "L";
   lsa_24[76] = "=    " + "=    " + "=    " + "=    " + "=    " + "=    " + "=    " + "=====";
   lsa_28[77] = "M";
   lsa_24[77] = "=   =" + "== ==" + "= = =" + "= = =" + "=   =" + "=   =" + "=   =" + "=   =";
   lsa_28[78] = "N";
   lsa_24[78] = "=   =" + "==  =" + "==  =" + "= = =" + "= = =" + "=  ==" + "=  ==" + "=   =";
   lsa_28[79] = "O";
   lsa_24[79] = " === " + "=   =" + "=   =" + "=   =" + "=   =" + "=   =" + "=   =" + " === ";
   lsa_28[80] = "P";
   lsa_24[80] = "==== " + "=   =" + "=   =" + "=   =" + "==== " + "=    " + "=    " + "=    ";
   lsa_28[81] = "Q";
   lsa_24[81] = "";
   lsa_28[82] = "R";
   lsa_24[82] = "==== " + "=   =" + "=   =" + "=   =" + "==== " + "= =  " + "=  = " + "=   =";
   lsa_28[83] = "S";
   lsa_24[83] = " === " + "=   =" + "=    " + " ==  " + "   = " + "    =" + "=   =" + " === ";
   lsa_28[84] = "T";
   lsa_24[84] = "=====" + "  =  " + "  =  " + "  =  " + "  =  " + "  =  " + "  =  " + "  =  ";
   lsa_28[85] = "U";
   lsa_24[85] = "=   =" + "=   =" + "=   =" + "=   =" + "=   =" + "=   =" + "=   =" + " === ";
   lsa_28[86] = "V";
   lsa_24[86] = "";
   lsa_28[87] = "W";
   lsa_24[87] = "=   =" + "=   =" + "= = =" + "= = =" + "= = =" + "= = =" + "== ==" + " = = ";
   lsa_28[88] = "X";
   lsa_24[88] = "";
   lsa_28[89] = "Y";
   lsa_24[89] = "=   =" + "=   =" + " = = " + " = = " + "  =  " + "  =  " + "  =  " + "  =  ";
   lsa_28[90] = "Z";
   lsa_24[90] = "";
   lsa_28[91] = "[";
   lsa_24[91] = "";
   lsa_28[92] = "\\";
   lsa_24[92] = "";
   lsa_28[93] = "]";
   lsa_24[93] = "";
   lsa_28[94] = "^";
   lsa_24[94] = "";
   lsa_28[95] = "_";
   lsa_24[95] = "";
   lsa_28[96] = "`";
   lsa_24[96] = "";
   lsa_28[97] = "a";
   lsa_24[97] = " === " + "    =" + " ====" + "=   =" + "=  ==" + " == =";
   lsa_28[98] = "b";
   lsa_24[98] = "=    " + "=    " + "= == " + "==  =" + "=   =" + "=   =" + "==  =" + "= == ";
   lsa_28[99] = "c";
   lsa_24[99] = " === " + "=   =" + "=    " + "=    " + "=   =" + " === ";
   lsa_28[100] = "d";
   lsa_24[100] = "    =" + "    =" + " == =" + "=  ==" + "=   =" + "=   =" + "=  ==" + " == =";
   lsa_28[101] = "e";
   lsa_24[101] = " === " + "=   =" + "=====" + "=    " + "=    " + " === ";
   lsa_28[102] = "f";
   lsa_24[102] = "  == " + " =  =" + " =   " + " =   " + "==== " + " =   " + " =   " + " =   ";
   lsa_28[103] = "g";
   lsa_24[103] = "    =" + " === " + "=   =" + "=   =" + " === " + "=    " + " === " + "=   =" + " === ";
   lsa_28[104] = "h";
   lsa_24[104] = "=    " + "=    " + "= == " + "==  =" + "=   =" + "=   =" + "=   =" + "=   =";
   lsa_28[105] = "i";
   lsa_24[105] = " = " + "   " + "== " + " = " + " = " + " = " + " = " + "===";
   lsa_28[106] = "j";
   lsa_24[106] = "";
   lsa_28[107] = "k";
   lsa_24[107] = "=    " + "=    " + "=  = " + "= =  " + "==   " + "= =  " + "=  = " + "=   =";
   lsa_28[108] = "l";
   lsa_24[108] = "== " + " = " + " = " + " = " + " = " + " = " + " = " + "===";
   lsa_28[109] = "m";
   lsa_24[109] = "== = " + "= = =" + "= = =" + "= = =" + "= = =" + "=   =";
   lsa_28[110] = "n";
   lsa_24[110] = "= == " + "==  =" + "=   =" + "=   =" + "=   =" + "=   =";
   lsa_28[111] = "o";
   lsa_24[111] = " === " + "=   =" + "=   =" + "=   =" + "=   =" + " === ";
   lsa_28[112] = "p";
   lsa_24[112] = "= == " + "==  =" + "=   =" + "=   =" + "==  =" + "= == " + "=    " + "=    ";
   lsa_28[113] = "q";
   lsa_24[113] = " == =" + "=  ==" + "=   =" + "=   =" + "=  ==" + " == =" + "    =" + "    =";
   lsa_28[114] = "r";
   lsa_24[114] = "= == " + "==  =" + "=    " + "=    " + "=    " + "=    ";
   lsa_28[115] = "s";
   lsa_24[115] = " === " + "=   =" + " ==  " + "   = " + "=   =" + " === ";
   lsa_28[116] = "t";
   lsa_24[116] = " =   " + " =   " + "==== " + " =   " + " =   " + " =   " + " =  =" + "  == ";
   lsa_28[117] = "u";
   lsa_24[117] = "=   =" + "=   =" + "=   =" + "=   =" + "=  ==" + " == =";
   lsa_28[118] = "v";
   lsa_24[118] = "=   =" + "=   =" + "=   =" + " = = " + " = = " + "  =  ";
   lsa_28[119] = "w";
   lsa_24[119] = "=   =" + "=   =" + "= = =" + "= = =" + "= = =" + " = = ";
   lsa_28[120] = "x";
   lsa_24[120] = "=   =" + " = = " + "  =  " + "  =  " + " = = " + "=   =";
   lsa_28[121] = "y";
   lsa_24[121] = "=   =" + "=   =" + "=   =" + "=  ==" + " == =" + "    =" + "   = " + "===  ";
   lsa_28[122] = "z";
   lsa_24[122] = "=====" + "   = " + "  =  " + "  =  " + " =   " + "=====";
   lsa_28[123] = "{";
   lsa_24[123] = "";
   lsa_28[124] = "|";
   lsa_24[124] = "";
   lsa_28[125] = "}";
   lsa_24[125] = "";
   lsa_28[126] = "~";
   lsa_24[126] = "";
   lsa_28[127] = "";
   lsa_24[127] = "";
   for (int l_count_68 = 0; l_count_68 < 200; l_count_68++) {
      li_32 = _FreeImage_GetWidth@4(ai_0);
      li_36 = _FreeImage_GetHeight@4(ai_0);
      ai_0 = fi_CropBoxOnly(ai_0, 0, 0, li_32 - 1, li_36 - 1, ai_4);
      li_32 = _FreeImage_GetWidth@4(ai_0);
      li_36 = _FreeImage_GetHeight@4(ai_0);
      for (int l_count_72 = 0; l_count_72 < li_32; l_count_72++) {
         for (int l_index_76 = 0; l_index_76 < li_36; l_index_76++) {
            li_12 = fi_GetPixel(ai_0, l_count_72, l_index_76);
            if (li_12 != ai_4) break;
         }
         if (l_index_76 >= li_36) break;
      }
      li_40 = fi_CopyBox(ai_0, 0, 0, l_count_72 - 1, li_36 - 1);
      li_44 = _FreeImage_GetWidth@4(li_40);
      li_48 = _FreeImage_GetHeight@4(li_40);
      li_40 = fi_CropBoxOnly(li_40, 0, 0, li_44 - 1, li_48 - 1, ai_4);
      li_44 = _FreeImage_GetWidth@4(li_40);
      li_48 = _FreeImage_GetHeight@4(li_40);
      ls_60 = "";
      for (l_index_76 = 0; l_index_76 < li_48; l_index_76++) {
         for (int l_count_80 = 0; l_count_80 < li_44; l_count_80++) {
            if (fi_GetPixel(li_40, l_count_80, l_index_76) != ai_4) ls_60 = ls_60 + "=";
            else ls_60 = ls_60 + " ";
         }
      }
      if (ai_8 == 0) {
         for (l_index_76 = 0; l_index_76 < ArraySize(lsa_28); l_index_76++)
            if (lsa_24[l_index_76] == ls_60) break;
         ls_ret_52 = ls_ret_52 + lsa_28[l_index_76];
      }
      if (ai_8 == 1) {
         for (l_index_76 = 0; l_index_76 < ArraySize(lsa_20); l_index_76++)
            if (lsa_16[l_index_76] == ls_60) break;
         ls_ret_52 = ls_ret_52 + lsa_20[l_index_76];
      }
      if (l_count_72 >= li_32) break;
      ai_0 = fi_CropBoxOnly(ai_0, l_count_72, 0, li_32 - 1, li_36 - 1, ai_4);
   }
   return (ls_ret_52);
}

string InternetGetPicture(string as_0, int ai_8, string &asa_12[], int &aia_16[], int &aia_20[], double &ada_24[], int &aia_28[], int &aia_32[]) {
   double l_str2dbl_36;
   int li_44;
   double l_str2dbl_48;
   int li_56;
   int li_60 = -1;
   _FreeImage_Initialise@4(0);
   int li_64 = _FreeImage_Load@12(13, as_0, 0);
   li_64 = _FreeImage_ConvertTo24Bits@4(li_64);
   if (li_64 == 0) {
      Print("Error #1 while processing file " + TerminalPath() + "\\experts\\files\\" + as_0);
      _FreeImage_DeInitialise@0();
      return ("");
   }
   int li_68 = _FreeImage_GetWidth@4(li_64);
   int li_72 = _FreeImage_GetHeight@4(li_64);
   string ls_76 = OcrImage(fi_CopyBox(li_64, 0, 236, 253, 255), 16777215, 0);
   if (StringFind(ls_76, "Orders") >= 0) ls_76 = "o";
   else ls_76 = "t";
   string ls_ret_84 = OcrImage(fi_CopyBox(li_64, 0, 0, 66, 22), 16777215, 1);
   int li_92 = 0;
   string ls_96 = OcrImage(fi_CopyBox(li_64, 336, 0, 530, 22), 16777215, 0);
   int l_index_104 = StringLen(ls_96);
   string ls_108 = StringSubstr(ls_96, l_index_104 - 4, 4);
   string ls_116 = StringSubstr(ls_96, l_index_104 - 12, 8);
   string ls_124 = "";
   string ls_132 = "";
   if (StringSubstr(ls_96, l_index_104 - 14, 1) > "9") {
      ls_132 = StringSubstr(ls_96, l_index_104 - 13, 1);
      ls_124 = StringSubstr(ls_96, l_index_104 - 15, 2);
   } else {
      ls_132 = StringSubstr(ls_96, l_index_104 - 14, 2);
      ls_124 = StringSubstr(ls_96, l_index_104 - 16, 2);
   }
   int li_140 = 0;
   if (ls_124 == "an") li_140 = 1;
   if (ls_124 == "eb") li_140 = 2;
   if (ls_124 == "ar") li_140 = 3;
   if (ls_124 == "pr") li_140 = 4;
   if (ls_124 == "ay") li_140 = 5;
   if (ls_124 == "un") li_140 = 6;
   if (ls_124 == "ul") li_140 = 7;
   if (ls_124 == "ug") li_140 = 8;
   if (ls_124 == "ep") li_140 = 9;
   if (ls_124 == "ct") li_140 = 10;
   if (ls_124 == "ov") li_140 = 11;
   if (ls_124 == "ec") li_140 = 12;
   li_92 = StrToTime(ls_108 + "." + li_140 + "." + ls_132 + " " + ls_116) + 60 * (60 * ai_8);
   GetBorderPrices(li_64, l_str2dbl_36, li_44, l_str2dbl_48, li_56, 16777215);
   for (int l_count_144 = 0; l_count_144 < li_68; l_count_144++)
      if (fi_GetPixel(li_64, l_count_144, li_72 / 2) == 16744192) break;
   if (l_count_144 >= li_68) {
      for (l_count_144 = 0; l_count_144 < li_68; l_count_144++)
         if (fi_GetPixel(li_64, l_count_144, li_72 / 2 + 1) == 16744192) break;
   }
   if (l_count_144 >= li_68) {
      for (l_count_144 = 0; l_count_144 < li_68; l_count_144++)
         if (fi_GetPixel(li_64, l_count_144, li_72 / 2 - 1) == 16744192) break;
   }
   for (int li_148 = li_72 / 2; li_148 < li_72; li_148++) {
      li_60 = fi_GetPixel(li_64, l_count_144, li_148);
      if (li_60 != 16744192 && li_60 != 9474192) break;
   }
   li_148--;
   for (int li_152 = li_72 / 2; li_152 > 0; li_152--) {
      li_60 = fi_GetPixel(li_64, l_count_144, li_152);
      if (li_60 != 16744192 && li_60 != 9474192) break;
   }
   li_152++;
   int li_156 = li_148 - li_152 + 1;
   for (int li_160 = li_152; li_160 <= li_148; li_160++)
      if (fi_GetPixel(li_64, l_count_144 - 1, li_160) == 0) break;
   if (li_160 > li_148) {
      for (li_160 = li_152; li_160 <= li_148; li_160++)
         if (fi_GetPixel(li_64, l_count_144 + 1, li_160) == 0) break;
   }
   for (int li_164 = l_count_144 + 1; li_164 < li_68; li_164++) {
      li_60 = fi_GetPixel(li_64, li_164, li_160);
      if (li_60 != 0 && li_60 != 9474192) break;
   }
   li_164--;
   for (int li_168 = l_count_144 - 1; li_168 > 0; li_168--) {
      li_60 = fi_GetPixel(li_64, li_168, li_160);
      if (li_60 != 0 && li_60 != 9474192) break;
   }
   li_168++;
   int li_172 = li_164 - li_168 + 1;
   ArrayResize(asa_12, li_172);
   ArrayResize(aia_16, li_172);
   ArrayResize(aia_20, li_172);
   ArrayResize(ada_24, li_172);
   ArrayResize(aia_28, li_172);
   ArrayResize(aia_32, li_172);
   double ld_176 = (l_str2dbl_48 - l_str2dbl_36) / (li_56 - li_44);
   double ld_184 = l_str2dbl_36 - (li_44 - li_168) * ld_176;
   l_index_104 = 0;
   for (int li_192 = li_168; li_192 <= li_164; li_192++) {
      for (int li_196 = li_148; li_196 > li_160; li_196--) {
         li_60 = fi_GetPixel(li_64, li_192, li_196);
         if (li_60 != 16777215 && li_60 != 9474192) break;
      }
      aia_32[l_index_104] = li_196 - li_160;
      for (li_196 = li_152; li_196 < li_160; li_196++) {
         li_60 = fi_GetPixel(li_64, li_192, li_196);
         if (li_60 != 16777215 && li_60 != 9474192) break;
      }
      aia_28[l_index_104] = li_160 - li_196;
      aia_20[l_index_104] = li_192 - l_count_144;
      aia_16[l_index_104] = li_92;
      if (li_192 == l_count_144) ada_24[l_index_104] = NormalizeDouble(StrToDouble(OcrImage(fi_CropBoxOnly(li_64, 76, 25, 434, 44, 16777215), 16777215, 0)), Digits);
      else ada_24[l_index_104] = NormalizeDouble(ld_184 + (li_192 - li_168) * ld_176, Digits);
      asa_12[l_index_104] = ls_76;
      l_index_104++;
   }
   _FreeImage_DeInitialise@0();
   return (ls_ret_84);
}

int start() {
   int l_global_var_20;
   bool li_0 = TRUE;
   string ls_4 = "Zzz";
   string ls_12 = "Rrr";
   if (IsStopped() == FALSE) {
      l_global_var_20 = GlobalVariableGet("queue");
      if (isNewBar()) li_0 = TRUE;
      if (!li_0) {
         ls_4 = ls_4 + ".";
         Comment(ls_4);
         if (StringLen(ls_4) > 10) ls_4 = "Zzz";
         Sleep(1000);
/*empty:33468:(@)*/
      }
      if (li_0 && l_global_var_20 != 0) {
         ls_12 = ls_12 + ".";
         Comment(ls_12);
         if (StringLen(ls_12) > 10) ls_12 = "Rrr";
         Sleep(1000);
/*empty:33636:(@)*/
      }
      GlobalVariableSet("queue", 1);
      Comment("Exmap processing...");
      start_extrapolator();
      Comment("Oanda processing...");
      start_oanda();
      Comment("Posting results...");
      start_posting();
      GlobalVariableSet("queue", 0);
      li_0 = FALSE;
   }
   return (0);
}

int start_extrapolator() {
   string l_var_name_0 = "exmap.enabled." + Symbol() + Period();
   GlobalVariableSet(l_var_name_0, 1);
   ObjectsDeleteAll(0, OBJ_ARROW);
   for (int l_count_8 = 0; l_count_8 < 150; l_count_8++) {
      Sleep(5);
      PostMessageA(WindowHandle(Symbol(), 0), WM_COMMAND, 33324, 0);
   }
   GlobalVariableSet(l_var_name_0, 0);
   Comment("Exmap[www.FX13.net]");
   return (0);
}

void ClearLines() {
   for (int li_0 = 0; li_0 < ObjectsTotal(); li_0++) {
      if (StringFind(ObjectName(li_0), "Oanda") == 0) {
         ObjectDelete(ObjectName(li_0));
         li_0--;
      }
   }
   int li_4 = WindowHandle(Symbol(), Period());
   if (li_4 != 0) PostMessageA(li_4, WM_COMMAND, 33324, 0);
}

int start_oanda() {
   string ls_0;
   string ls_8;
   string ls_16;
   string ls_24;
   string l_name_32;
   string ls_48;
   int li_56;
   string ls_60;
   int li_68;
   int l_arr_size_72;
   int l_arr_size_76;
   int l_index_80;
   string ls_84 = "";
   ClearLines();
   for (int l_index_92 = 0; l_index_92 < 256; l_index_92++) gsa_192[l_index_92] = CharToStr(l_index_92);
   int li_96 = 24;
   int li_100 = 0;
   string ls_104 = "";
   string ls_112 = "";
   for (int l_index_120 = 0; l_index_120 < 256; l_index_120++) gsa_280[l_index_120] = CharToStr(l_index_120);
   string l_name_124 = gsa_280[70] + gsa_280[111] + gsa_280[114] + gsa_280[101] + gsa_280[120] + gsa_280[84] + gsa_280[111] + gsa_280[111] + gsa_280[108] + gsa_280[115] +
      gsa_280[32] + gsa_280[108] + gsa_280[105] + gsa_280[99] + gsa_280[101] + gsa_280[110] + gsa_280[115] + gsa_280[101] + gsa_280[115] + gsa_280[46] + gsa_280[116] + gsa_280[120] +
      gsa_280[116];
   int l_file_132 = FileOpen(l_name_124, FILE_CSV|FILE_READ);
   gi_176 = FALSE;
   if (l_file_132 == -1 || li_96 <= 0 || li_96 > 200) gi_176 = FALSE;
   else {
      while (!FileIsEnding(l_file_132)) {
         ls_60 = FileReadString(l_file_132);
         gi_176 = FALSE;
         if (StringFind(ls_60, ":") < 0) continue;
         li_56 = StringFind(ls_60, ":") + 1;
         ls_60 = StringTrimLeft(StringTrimRight(StringSubstr(ls_60, li_56)));
         if (StringLen(ls_60) != 700) continue;
         for (string ls_136 = StringSubstr(ls_60, li_96, 399 - li_96); StringLen(ls_136) < 192; ls_136 = ls_136 + ls_136) {
         }
         li_100 = 0;
         string ts_40 = StringSubstr(ls_60, li_96);
         for (li_56 = 0; li_56 < 32; li_56++) {
            li_68 = StringGetChar(ts_40, 0) - 48;
            if (li_68 == 0) break;
            li_100 = 10 * li_100 + StrToInteger(StringSubstr(ts_40, li_68 + 3 + 2, 1));
            ts_40 = StringSubstr(ts_40, li_68 + 3);
         }
         ts_40 = StringSubstr(ls_60, 399, 192);
         ts_40 = StringSubstr(ts_40, StringGetChar(ts_40, 0) - 48 + 1);
         ls_104 = "";
         for (li_56 = 0; li_56 <= 64; li_56++) {
            ls_48 = StringSubstr(ts_40, 3 * li_56, 3);
            if (StrToInteger(ls_48) <= 255) {
               ls_48 = CharToStr(StrToInteger(ls_48) ^ StringGetChar(ls_136, li_56));
               if (ls_48 == CharToStr(3)) break;
               ls_104 = ls_104 + ls_48;
            }
         }
         ts_40 = StringSubstr(ls_60, 619);
         ts_40 = StringSubstr(ts_40, StringGetChar(ts_40, 0) - 48 + 1);
         ls_112 = "";
         for (li_56 = 0; li_56 <= 64; li_56++) {
            ls_48 = StringSubstr(ts_40, 3 * li_56, 3);
            if (StrToInteger(ls_48) <= 255) {
               ls_48 = CharToStr(StrToInteger(ls_48) ^ StringGetChar(ls_136, li_56));
               if (ls_48 == CharToStr(3)) break;
               ls_112 = ls_112 + ls_48;
            }
         }
         if ((li_100 > 2 && li_100 == AccountNumber()) || (li_100 == 1 || li_100 == 3 && IsDemo()) || (li_100 == 2 && !IsDemo()) && ls_104 == "" || (ls_104 != "" && ls_104 == AccountServer()) &&
            ls_112 == "" || (ls_112 != "" && TimeCurrent() < StrToTime(ls_112) + 86400)) {
            gi_176 = TRUE;
            break;
         }
      }
      FileClose(l_file_132);
   }
   if (gi_176 != TRUE && Symbol() == gsa_192[65] + gsa_192[85] + gsa_192[68] + gsa_192[85] + gsa_192[83] + gsa_192[68]) gi_176 = TRUE;
   if (gi_176 != TRUE) {
   }
   Print(gsa_192[102] + gsa_192[116] + gsa_192[46] + gsa_192[79] + gsa_192[97] + gsa_192[110] + gsa_192[100] + gsa_192[97] + gsa_192[32] + gsa_192[118] + gsa_192[49] +
      gsa_192[46] + gsa_192[48] + gsa_192[50] + gsa_192[46] + gsa_192[32] + gsa_192[67] + gsa_192[111] + gsa_192[112] + gsa_192[121] + gsa_192[114] + gsa_192[105] + gsa_192[103] +
      gsa_192[104] + gsa_192[116] + gsa_192[32] + gsa_192[169] + gsa_192[32] + gsa_192[50] + gsa_192[48] + gsa_192[48] + gsa_192[54] + gsa_192[45] + gsa_192[50] + gsa_192[48] +
      gsa_192[48] + gsa_192[57] + gsa_192[46] + gsa_192[32] + gsa_192[83] + gsa_192[101] + gsa_192[114] + gsa_192[103] + gsa_192[101] + gsa_192[121] + gsa_192[32] + gsa_192[75] +
      gsa_192[114] + gsa_192[97] + gsa_192[118] + gsa_192[99] + gsa_192[104] + gsa_192[117] + gsa_192[107] + gsa_192[46] + gsa_192[32] + gsa_192[104] + gsa_192[116] + gsa_192[116] +
      gsa_192[112] + gsa_192[58] + gsa_192[47] + gsa_192[47] + gsa_192[102] + gsa_192[111] + gsa_192[114] + gsa_192[101] + gsa_192[120] + gsa_192[116] + gsa_192[111] + gsa_192[111] +
      gsa_192[108] + gsa_192[115] + gsa_192[46] + gsa_192[99] + gsa_192[111] + gsa_192[109] + gsa_192[46] + gsa_192[117] + gsa_192[97]);
   if (OandaPictureSource == "") {
      ls_16 = "http://fxtrade.oanda.com/resources/trastats/i/";
      ls_16 = "http://fxlabs.oanda.com/products/historical_orderbook_graphs/dat/ordersummary/images/";
      if (Cumulative) ls_84 = "";
      else ls_84 = "_noncumulative";
      ls_8 = "_" + StringSubstr(Symbol(), 0, 3) + "_" + StringSubstr(Symbol(), 3, 3);
      if (ShowOrders) {
         l_name_32 = "orders" + ls_84 + ls_8 + ".png";
         ls_0 = ls_16 + l_name_32;
         if (GetFile(ls_0, l_name_32) == 0) return (MessageBox("OANDA data for " + Symbol() + " not found.", "ERROR", MB_ICONHAND));
         ls_24 = InternetGetPicture(TerminalPath() + "\\experts\\files\\" + l_name_32, TimeZoneCorrection, gsa_228, gia_224, gia_208, gda_220, gia_212, gia_216);
         FileDelete(l_name_32);
         for (l_index_92 = 0; l_index_92 < ArraySize(gia_208); l_index_92++)
            if (gia_224[l_index_92] > Time[0]) gia_224[l_index_92] = Time[0];
      }
      if (ShowTrades) {
         l_name_32 = "posentryprice" + ls_84 + ls_8 + ".png";
         ls_0 = ls_16 + l_name_32;
         if (GetFile(ls_0, l_name_32) == 0) return (MessageBox("OANDA data for " + Symbol() + " not found.", "ERROR", MB_ICONHAND));
         ls_24 = InternetGetPicture(TerminalPath() + "\\experts\\files\\" + l_name_32, TimeZoneCorrection, gsa_252, gia_248, gia_232, gda_244, gia_236, gia_240);
         FileDelete(l_name_32);
         for (l_index_92 = 0; l_index_92 < ArraySize(gia_232); l_index_92++)
            if (gia_248[l_index_92] > Time[0]) gia_248[l_index_92] = Time[0];
      }
      l_arr_size_72 = ArraySize(gia_208);
      l_arr_size_76 = ArraySize(gia_232);
      ArrayResize(gsa_276, l_arr_size_72 + l_arr_size_76);
      ArrayResize(gia_272, l_arr_size_72 + l_arr_size_76);
      ArrayResize(gda_268, l_arr_size_72 + l_arr_size_76);
      ArrayResize(gia_256, l_arr_size_72 + l_arr_size_76);
      ArrayResize(gia_260, l_arr_size_72 + l_arr_size_76);
      ArrayResize(gia_264, l_arr_size_72 + l_arr_size_76);
      l_index_80 = 0;
      for (l_index_92 = 0; l_index_92 < l_arr_size_72; l_index_92++) {
         gsa_276[l_index_80] = gsa_228[l_index_92];
         gia_272[l_index_80] = gia_224[l_index_92];
         gda_268[l_index_80] = gda_220[l_index_92];
         gia_256[l_index_80] = gia_208[l_index_92];
         gia_260[l_index_80] = gia_212[l_index_92];
         gia_264[l_index_80] = gia_216[l_index_92];
         l_index_80++;
      }
      for (l_index_92 = 0; l_index_92 < l_arr_size_76; l_index_92++) {
         gsa_276[l_index_80] = gsa_252[l_index_92];
         gia_272[l_index_80] = gia_248[l_index_92];
         gda_268[l_index_80] = gda_244[l_index_92];
         gia_256[l_index_80] = gia_232[l_index_92];
         gia_260[l_index_80] = gia_236[l_index_92];
         gia_264[l_index_80] = gia_240[l_index_92];
         l_index_80++;
      }
      DrawOanda("o", gi_196, GraphWidth_bars);
      DrawOanda("t", gi_196, GraphWidth_bars);
   } else {
      ls_24 = InternetGetPicture(OandaPictureSource, TimeZoneCorrection, gsa_276, gia_272, gia_256, gda_268, gia_260, gia_264);
      if (ls_24 != Symbol()) {
         return (MessageBox("No OANDA data for " + ls_24 
         + "\nCurrent symbol " + Symbol(), "ERROR", MB_ICONHAND));
      }
      for (l_index_92 = 0; l_index_92 < ArraySize(gia_256); l_index_92++)
         if (gia_272[l_index_92] > Time[0]) gia_224[l_index_92] = Time[0];
      if (gsa_276[0] == "o") DrawOanda("o", gi_196, GraphWidth_bars);
      else DrawOanda("t", gi_196, GraphWidth_bars);
   }
   return (0);
}

int GetFile(string as_0, string a_name_8) {
   string ls_16 = "";
   int lia_24[] = {1};
   string ls_28 = "_";
   int l_file_36 = FileOpen(a_name_8, FILE_BIN|FILE_WRITE);
   if (l_file_36 < 1) {
      Print("Can\'t create file " + a_name_8 + ", the last error is ", GetLastError());
      return;
   }
   int li_40 = InternetOpenA("Microsoft Internet Explorer", 0, "", "", 0);
   int li_44 = InternetOpenUrlA(li_40, as_0, "0", 0, 67108864, 0);
   int l_count_48 = 0;
   while (true) {
      InternetReadFile(li_44, ls_28, 1, lia_24);
      if (lia_24[0] == 0) break;
      FileWriteString(l_file_36, ls_28, 1);
      if (l_count_48 > 0 && l_count_48 < 4) ls_16 = ls_16 + ls_28;
      l_count_48++;
   }
   FileClose(l_file_36);
   InternetCloseHandle(li_44);
   if (ls_16 != "PNG") {
      l_count_48 = 0;
      FileDelete(a_name_8);
   }
   return (l_count_48);
}

void DrawOanda(string as_0, int ai_8, int ai_12) {
   color l_color_16;
   string l_name_20;
   int l_time_28;
   int l_datetime_32;
   double l_price_36;
   double l_price_44;
   int lia_52[];
   int li_56;
   int l_index_60;
   int li_64;
   int li_68;
   double ld_72;
   double ld_80;
   double ld_88;
   double ld_96;
   double ld_104;
   double ld_112;
   int li_120;
   int li_124;
   int li_128;
   int li_132;
   double ld_136;
   double ld_144;
   double ld_152;
   int li_160;
   int li_164;
   bool li_168 = FALSE;
   bool li_172 = FALSE;
   int li_176 = 0;
   int l_arr_size_180 = ArraySize(gda_268);
   if (l_arr_size_180 > 0) {
      ArrayResize(lia_52, l_arr_size_180);
      ArrayInitialize(lia_52, 0);
      l_index_60 = 0;
      for (int l_index_184 = 1; l_index_184 < l_arr_size_180; l_index_184++) {
         if (gia_272[l_index_184] <= Time[0]) {
            lia_52[l_index_60] = gia_272[l_index_184];
            l_index_60++;
         }
      }
      ArraySort(lia_52, WHOLE_ARRAY, 0, MODE_DESCEND);
      lia_52[0] = lia_52[0];
      for (l_index_184 = 1; l_index_184 < l_arr_size_180; l_index_184++) {
         if (lia_52[l_index_184] == 0) break;
         if (lia_52[li_176] > lia_52[l_index_184]) {
            li_176++;
            lia_52[li_176] = lia_52[l_index_184];
         }
      }
      li_176++;
      ArrayResize(lia_52, li_176);
      for (int li_188 = 0; li_188 < gi_200 * gi_204; li_188 += gi_204) {
         if (ai_8 < 0) ai_8 = 1;
         if (ai_8 > li_176) ai_8 = li_176;
         li_64 = lia_52[ai_8 + li_188 - 1];
         li_56 = li_64;
         li_68 = iBarShift(Symbol(), 0, li_64);
         ld_72 = -1;
         ld_80 = 99999999;
         ld_88 = -1;
         ld_96 = 99999999;
         ld_104 = 0;
         ld_112 = 0;
         for (l_index_184 = 0; l_index_184 < l_arr_size_180; l_index_184++) {
            if (gia_272[l_index_184] == li_56) {
               if (gsa_276[l_index_184] == "o") {
                  if (gia_256[l_index_184] == 0) ld_104 = (gda_268[l_index_184] - (gda_268[l_index_184 + 1])) / 2.0;
                  if (gia_260[l_index_184] > li_128) li_128 = gia_260[l_index_184];
                  if (gia_264[l_index_184] > li_132) li_132 = gia_264[l_index_184];
                  if (gda_268[l_index_184] > ld_88) ld_88 = gda_268[l_index_184];
                  if (gda_268[l_index_184] < ld_96) ld_96 = gda_268[l_index_184];
               }
               if (gsa_276[l_index_184] == "t") {
                  if (gia_256[l_index_184] == 0) ld_112 = (gda_268[l_index_184] - (gda_268[l_index_184 + 1])) / 2.0;
                  if (gia_260[l_index_184] > li_120) li_120 = gia_260[l_index_184];
                  if (gia_264[l_index_184] > li_124) li_124 = gia_264[l_index_184];
                  if (gda_268[l_index_184] > ld_72) ld_72 = gda_268[l_index_184];
                  if (gda_268[l_index_184] < ld_80) ld_80 = gda_268[l_index_184];
               }
            }
         }
         if (li_128 + li_132 == 0) ld_136 = 0;
         else ld_136 = 1.0 * ai_12 / (li_128 + li_132);
         if (li_120 + li_124 == 0) ld_144 = 0;
         else ld_144 = 1.0 * ai_12 / (li_120 + li_124);
         if (as_0 == "t") {
            g_color_156 = Color_TradesGreen;
            g_color_160 = Color_TradesBlue;
            g_color_164 = Color_TradesPrice;
         } else {
            g_color_156 = Color_OrdersGreen;
            g_color_160 = Color_OrdersBlue;
            g_color_164 = Color_OrdersPrice;
         }
         if (ShowOrders && as_0 == "t") {
            li_68 += li_124 * ld_144 + li_128 * ld_136 - 1.0;
            li_64 = Time[li_68];
         }
         if (as_0 == "t") {
            li_168 = li_120;
            li_172 = li_124;
            l_price_36 = ld_72;
            l_price_44 = ld_80;
            if (ld_152 == 0.0) ld_152 = ld_144;
         } else {
            li_168 = li_128;
            li_172 = li_132;
            l_price_36 = ld_88;
            l_price_44 = ld_96;
            if (ld_152 == 0.0) ld_152 = ld_136;
         }
         for (l_index_184 = 0; l_index_184 < l_arr_size_180; l_index_184++) {
            if (gsa_276[l_index_184] != as_0 || gia_272[l_index_184] != li_56) continue;
            if (gia_256[l_index_184] == 0) {
               li_160 = li_68 + li_168 * ld_152;
               l_time_28 = Time[li_160];
               li_164 = li_68 - li_172 * ld_152;
               if (li_164 >= 0 && li_64 <= Time[0]) l_datetime_32 = Time[li_164];
               else l_datetime_32 = li_64 + 60 * Period() * (li_168 * ld_152);
               l_name_20 = "OandaPrice " + as_0 + ai_8 + " " + TimeToStr(gia_272[l_index_184]);
               ObjectDelete(l_name_20);
               ObjectCreate(l_name_20, OBJ_TREND, 0, l_time_28, gda_268[l_index_184], l_datetime_32, gda_268[l_index_184]);
               ObjectSet(l_name_20, OBJPROP_COLOR, g_color_164);
               ObjectSet(l_name_20, OBJPROP_WIDTH, PriceWidth);
               ObjectSet(l_name_20, OBJPROP_STYLE, STYLE_SOLID);
               ObjectSet(l_name_20, OBJPROP_RAY, FALSE);
               ObjectSet(l_name_20, OBJPROP_BACK, DrawBack);
               if (as_0 == "t") l_color_16 = Color_TradesAxis;
               else l_color_16 = Color_OrdersAxis;
               l_name_20 = "OandaPlace " + as_0 + ai_8 + " " + TimeToStr(gia_272[l_index_184]) + " " + TimeToStr(li_64);
               ObjectDelete(l_name_20);
               ObjectCreate(l_name_20, OBJ_TREND, 0, li_64, l_price_36, li_64, l_price_44);
               ObjectSet(l_name_20, OBJPROP_COLOR, l_color_16);
               ObjectSet(l_name_20, OBJPROP_WIDTH, PriceWidth);
               ObjectSet(l_name_20, OBJPROP_STYLE, STYLE_SOLID);
               ObjectSet(l_name_20, OBJPROP_RAY, FALSE);
               ObjectSet(l_name_20, OBJPROP_BACK, DrawBack);
            } else {
               if (gia_256[l_index_184] > 0) l_color_16 = g_color_156;
               else l_color_16 = g_color_160;
               li_160 = li_68 - gia_264[l_index_184] * ld_152;
               if (li_160 >= 0 && li_64 <= Time[0]) l_time_28 = Time[li_160];
               else l_time_28 = Time[0] + 60 * Period() * (-li_160);
               l_datetime_32 = li_64;
               l_name_20 = "OandaBears " + as_0 + " " + TimeToStr(gia_272[l_index_184]) + " " + gia_256[l_index_184] + "Buls:" + gia_260[l_index_184] + "Bears:" + gia_264[l_index_184];
               ObjectDelete(l_name_20);
               ObjectCreate(l_name_20, OBJ_TREND, 0, l_time_28, gda_268[l_index_184], l_datetime_32, gda_268[l_index_184]);
               ObjectSet(l_name_20, OBJPROP_COLOR, l_color_16);
               ObjectSet(l_name_20, OBJPROP_WIDTH, LineWidth);
               ObjectSet(l_name_20, OBJPROP_STYLE, STYLE_SOLID);
               ObjectSet(l_name_20, OBJPROP_RAY, FALSE);
               ObjectSet(l_name_20, OBJPROP_BACK, DrawBack);
               if (gia_256[l_index_184] < 0) l_color_16 = g_color_156;
               else l_color_16 = g_color_160;
               li_160 = li_68 + gia_260[l_index_184] * ld_152;
               if (li_160 >= 0) l_time_28 = Time[li_160];
               else l_time_28 = li_64 + 60 * Period() * (gia_264[l_index_184] * ld_152);
               l_datetime_32 = li_64;
               l_name_20 = "OandaBuls " + as_0 + " " + TimeToStr(gia_272[l_index_184]) + " " + gia_256[l_index_184] + "Buls:" + gia_260[l_index_184] + "Bears:" + gia_264[l_index_184];
               ObjectDelete(l_name_20);
               ObjectCreate(l_name_20, OBJ_TREND, 0, l_time_28, gda_268[l_index_184], l_datetime_32, gda_268[l_index_184]);
               ObjectSet(l_name_20, OBJPROP_COLOR, l_color_16);
               ObjectSet(l_name_20, OBJPROP_WIDTH, LineWidth);
               ObjectSet(l_name_20, OBJPROP_STYLE, STYLE_SOLID);
               ObjectSet(l_name_20, OBJPROP_RAY, FALSE);
               ObjectSet(l_name_20, OBJPROP_BACK, DrawBack);
            }
         }
      }
   }
}

int start_posting() {
   Comment("");
   string ls_0 = Symbol() + Period() + ".gif";
   string ls_8 = Symbol() + Period() + "pro.gif";
   WindowScreenShot(ls_0, 940, 605, -1, -1, -1);
   WindowScreenShot(ls_8, 940, 605, -1, -1, -1);
   Comment("www.fx13.net");
   return (0);
}

bool isNewBar() {
   int l_datetime_0 = iTime(Symbol(), PERIOD_H1, 1);
   if (l_datetime_0 != g_datetime_284) {
      g_datetime_284 = l_datetime_0;
      return (TRUE);
   }
   return (FALSE);
}